//
//  AudioFileSet.h
//  Borderlands
//
//  Created by Christopher Carlson on 11/21/11.
//  Copyright 2011 Stanford University. All rights reserved.
//


#ifndef AUDIOFILESET_H
#define AUDIOFILESET_H

#include <vector>
#include <string>
#include "libsnd/sndfile.h"
#include "dirent.h"
#include  <iostream>
#include "setup.h"
//#include "theglobals.h"
using namespace std;


//basic encapsulation of an audio file
struct AudioFile{
    
    //constructor
    AudioFile(string myName,string thePath,unsigned int numChan, unsigned long numFrames,unsigned int srate, SAMPLE * theWave)
    {
        cout << numFrames << endl;
        this->name = myName;
        this->path = thePath;
        this->frames = numFrames;
        this->lengthSamps = numFrames * numChan;
        this->channels = numChan;
        this->sampleRate = srate;
        this->wave = theWave;

    }
    //destructor
    ~AudioFile(){
        if (wave != NULL){
            delete [] wave;
        }
    }
    
    string name;
    string path;
    SAMPLE * wave;
    unsigned long frames;
    unsigned long lengthSamps;
    unsigned int channels;
    unsigned int sampleRate;
};



class AudioFileSet
{
    
public:
    virtual ~AudioFileSet();
    
    //constructor
    AudioFileSet();
    
    //read in all audio files contained in 
    int loadFileSet(string path);
    
    // return how many files were found
    int getNumFiles(){return m_numFiles;};
    
    //return the audio vector- note, the intension is for the files to be
    //read only.  if write access is needed in the future - thread safety will
    //need to be considered
    vector<AudioFile *> * getFileVector();
    
    
private:    
    vector<AudioFile *> * fileSet;
    int m_numFiles;

};



#endif