//
//  JifChannelGui.h
//  glMovingLines
//
//  Created by Jiffer Harriman on 11/22/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#ifndef JIFCHANNELGUI_H
#define JIFCHANNELGUI_H

#include "JifGL.h"
#include "JifDropletGui.h"
#include "JifVerticalRect.h"

#include "SlaveDrop.h"

class JifChannelGui {
    int m_numBeats;
    int m_id;
    float m_yInc;
    float m_chanWidth;
    bool * m_pickedArray;
    JifVerticalRect * m_channelBox;
    JifDropletGui ** m_dropArray;
    JifDrop * m_theDropper;
    
    bool m_animate;
    
public:
    JifChannelGui(int chanNum, float position);
    ~JifChannelGui(){};
        
    // reshape function
    void setWindowShape(int w, int h);
    
    // display function
    void draw(GLenum, JifDrop * channelDrop);
    void drawMasterBeats();
    
    // motion function
    bool procMovement(int x, int y);
    
    // mouse function
    int pick(int button, int state, int x, int y);
    
    void clearLastPicked();
    void procHits(GLint hits, GLuint buffer[]);
    
    void setNumBeats(int numBeats);
    void setTop(float newHeight);
    void setDropSpacing();
    
    float getTopData(){return m_channelBox->getTopData();};
    void setBottomData(int data){m_channelBox->setBottomData(data);};

    float getHorizontal(){return m_channelBox->getHorizontal();};
    float getYinc(){return m_yInc;};
    
    int getNumBeats(){return (int)(m_channelBox->getBottomData());};
    int getMasterBeatsLoopRate();
    
    void setAnimate(bool animate);
    bool getAnimate(){return m_animate;};
    void setDropper(JifDrop * theDrop){
        m_channelBox->setDropper(theDrop);
        for (int i = 0; i < m_numBeats; i++){
            m_theDropper = theDrop;
            m_dropArray[i]->setDropper(theDrop);
        }
        
    }
    
};

#endif