//
//  JifDropletGui.cpp
//  glMovingLines
//
//  Created by Jiffer Harriman on 11/22/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#include "JifDropletGui.h"


JifDropletGui::JifDropletGui(int chan, int beat, float x, float y){
    m_theDrop = new JifDrop();
    
    m_ChannelId = chan;
    m_BeatId = beat + 4; // offset of 4 because the rectangle occupies names 0-3
    // m_radius = 0.025;
    m_yOffset = y;
    m_xOffset = x;
    
    m_screenWidth = WIDTH;
    m_screenHeight = HEIGHT;
    m_screenWidthOverHeight = m_screenWidth/m_screenHeight;
    m_enabled = 0;
    
    // calculate the scale factor
    // this is used to determine how much to move the edges by based on the window size
    m_screenScaleW = SCREENNORM / m_screenWidth;
    m_screenScaleH = SCREENNORM / m_screenHeight;
    
    // initialize animated drop color:
    m_color = new GLfloat[4];
    m_color[0] = 0.2;
    m_color[1] = 0.2;
    m_color[2] = 1.0;
    m_color[3] = 1.0;
    
    // initialize animated drop color:
    m_muteColor = new GLfloat[4];
    m_muteColor[0] = 1.0;
    m_muteColor[1] = 0.0;
    m_muteColor[2] = 0.0;
    m_muteColor[3] = 1.0;
    
}

JifDropletGui::~JifDropletGui(){
    
}

// reshape function
void JifDropletGui::setWindowShape(int w, int h){
    m_screenWidth = w;
    m_screenHeight = h;
    m_screenWidthOverHeight = m_screenWidth/m_screenHeight;
    // TODO change the radius somehow
}

// display function
void JifDropletGui::draw(GLenum mode){
    
    if (mode == GL_SELECT)
        glLoadName(m_ChannelId * NAMEINCREMENT + m_BeatId); // increment by NAMEINCREMENT so names don't clobber each other
    float angle;
    
    glLineWidth(2.0);
    if (m_enabled)
        glColor4f(0.2f, 0.2f, 0.8f, 1.0f); 
    else
        glColor4f(0.2, 0.2, 0.2, 0.5);
    glBegin(GL_LINE_LOOP); 
    for(int i = 0; i < 100; i++) { 
        angle = i*2*M_PI/100;
        glVertex2f(m_xOffset + cos(angle) * (0.025), m_yOffset + m_screenWidthOverHeight*(sin(angle) * 0.025)); 
    } 
    glEnd(); 
    
}

void JifDropletGui::animate(){
    // only draw enabled drops for animation
    if(m_enabled){
        glPushMatrix();
        if (m_theDrop->getMute())
            glMaterialfv(GL_FRONT,GL_DIFFUSE,m_muteColor);
        else
            glMaterialfv(GL_FRONT,GL_DIFFUSE,m_color);
        glTranslated(m_xOffset, m_yOffset, 0);
        //glColor4f(0.2, 0.2, 1.0, 1.0);
        glutSolidSphere(0.055, 20, 20);
        glPopMatrix();
    }
}

// motion function
void JifDropletGui::procMovement(int x, int y){
    
}

// mouse function
void JifDropletGui::pick(int button, int state, int x, int y){
    
    // don't think I need this here but up where there is an array of them
    
}
