//
//  JifRect.h
//  glMovingLines
//
//  Created by Jiffer Harriman on 11/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#ifndef JIFRECT_H
#define JIFRECT_H

#include "JifGL.h"
#include "JifDrop.h"

enum LINEID {
    TOP,
    BOTTOM,
    LEFT, 
    RIGHT
};

class JifRect {
protected:
    int m_id;  // assign when created to keep track of which rectangle is being accessed
    float m_top, m_bottom, m_left, m_right;
    float m_horizontalOffset;
    float m_color_r, m_color_g, m_color_b;
    bool * m_pickedArray;
    float m_screenScaleW;
    float m_screenScaleH;
    int m_screenWidth;
    int m_screenHeight;
    bool m_buttonState;
    JifDrop * m_theDrop;
    
public:
    JifRect();
    JifRect(int rect_id, float offset);
    JifRect(int rect_id, float offset, float left, float right, float top, float bottom);
    void init(int screenWidth, int screenHeight, float offset, float left, float right, float top, float bottom);
    ~JifRect();
    void pick(int button, int state, int x, int y);
    void procHits(GLint hits, GLuint buffer[]);
    void procMovement(int x, int y);
    void draw(GLenum);
    void clearLastPicked();
    void setWindowShape(int w, int h);
    float getTop(){return m_top;};
    void setTop(float h){m_top = h;};
    
    float getRectHeight() {return (float)(m_top - m_bottom);}; 
    float getRectWidth() {return (float)(m_right - m_left);};
    
    void setDropper(JifDrop * theDropper){m_theDrop = theDropper;};
};

#endif