//
//  JifVerticalRect.cpp
//  glMovingLines
//
//  Created by Jiffer Harriman on 11/22/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
//
//  Inherits from JifRect class
// 
//  This only allows the top of the rectangle to be moved when "picked"
//  The other sides of the rectangle can update parameters when clicked on and dragged but their position won't change

#include "JifVerticalRect.h"

JifVerticalRect::JifVerticalRect(){
    
    
}

JifVerticalRect::~JifVerticalRect(){
    
}

// process mouse movement
// if one of the lines is selected update data for that line and return which data was updated
bool JifVerticalRect::procMovement(int x, int y){   
    bool returnVal = false;
    
    for (int i = 0; i<4; i++){
        if (m_pickedArray[i] == 1)
            switch (i) {
                case TOP:
                    returnVal = true;
                    m_top = (m_screenHeight - y) * m_screenScaleH;

                    if (m_top > SINKMAX)
                        m_top = SINKMAX;
                    else if (m_top < SINKMIN)
                        m_top = SINKMIN;
                    
                    // scales data to 0 to 1 for an initial seperation of 5
                    m_topData = ((m_top - SINKMIN) / (SINKMAX - SINKMIN) );
//                    printf("%f\n", m_topData);
                 
                    break;
                    
                case BOTTOM:
                    //m_bottom = (m_screenHeight - y) * m_screenScaleH;
                    if (m_buttonState)
                        m_bottomData = (float) (m_bottomData + (m_screenScaleH * (m_screenHeight - y) - m_bottom));
                    if (m_bottomData < 1)
                        m_bottomData = 1;
                    else if (m_bottomData > MAXDROPS)
                        m_bottomData = MAXDROPS;
                    
                    // printf("%f\n", m_bottomData);
                    //return BOTTOM;
                    break;
                case RIGHT:
                    m_rightData =(int)((x * m_screenScaleW - m_right) / m_screenScaleW)/5;
                    //printf("%f\n", m_rightData);
                    //return RIGHT;
                    break;
                case LEFT:
                    m_leftData =(int)((x * m_screenScaleW - m_left) / m_screenScaleW)/5;
                    // return LEFT;
                    break;
                    
                default:
                    break;
            }
    }    
    return returnVal;
}

int JifVerticalRect::pick(int button, int state, int x, int y)
{
    clearLastPicked();
    
    
    if (state == GLUT_DOWN)
        m_buttonState = 1;
    else
        m_buttonState = 0;
    
    GLuint selectBuf[JIFPICKBUFSIZE];
    GLint hits;
    GLint viewport[4];
    
    if (button != GLUT_LEFT_BUTTON || state != GLUT_DOWN)
        return MAXDROPS;
    
    glGetIntegerv(GL_VIEWPORT, viewport);
    
    glSelectBuffer(JIFPICKBUFSIZE, selectBuf);
    
    // Change to Select mode
    (void) glRenderMode(GL_SELECT);
    
    glInitNames();
    glPushName(0);
    
    glMatrixMode(GL_PROJECTION);
    glPushMatrix();
    glLoadIdentity();
    
    /*  create 10x10 pixel picking region near cursor location */
    gluPickMatrix((GLdouble) x, (GLdouble) (viewport[3] - y), 10.0, 10.0, viewport);
    glOrtho(0.0, 8.0, 0.0, 8.0, -0.5, 2.5);
    
    // call draw function in select mode:
    draw(GL_SELECT);
    glPopMatrix();
    glFlush();
    
    hits = glRenderMode(GL_RENDER);
    
    // process the hits returned
    procHits(hits, selectBuf);
    
    if (hits > 0){
        return selectBuf[3]%(NAMEINCREMENT*m_id);
    }
    else return MAXDROPS; // if not picking one of the sides of this rectangle
    
}

void JifVerticalRect::setTop(float newTop){
    m_top = newTop;
    m_topData = ((m_top - SINKMIN) / (SINKMAX - SINKMIN) );
}

void JifVerticalRect::animate(float offset){

    glPushMatrix();
    glMaterialfv(GL_FRONT,GL_DIFFUSE,m_color);

    glTranslatef(m_left+.1, offset, 0.0);
    glRotated(270,1, 0, 0);
    glutSolidCone(0.1, 0.2, 10, 10);
    glPopMatrix();
}
