//
//  JifVerticalRect.h
//  glMovingLines
//
//  Created by Jiffer Harriman on 11/22/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#ifndef JIFVERTICALRECT_H
#define JIFVERTICALRECT_H

#include "JifGL.h"
#include "JifRect.h"
#include "JifDrop.h"

class JifVerticalRect : public JifRect
{
    float m_rightData, m_leftData, m_topData, m_bottomData;
    bool m_dataChanged;
    GLfloat * m_color;
    

    
    
public:
    JifVerticalRect();
    JifVerticalRect(int rect_id, float offset):JifRect(rect_id, offset){m_bottomData = INITDROPS; m_topData = (SINKTOP - SINKMIN) / (SINKMAX - SINKMIN);     
        // initialize animated drop color:
        m_color = new GLfloat[4];
        m_color[0] = 0.5;
        m_color[1] = 0.5;
        m_color[2] = 0.5;
        m_color[3] = 0.5;
};
    JifVerticalRect(int rect_id, float offset, float left, float right, float top, float bottom):JifRect(rect_id, offset, left, right, top, bottom){m_bottomData = INITDROPS; m_topData = (top - SINKMIN) / (SINKMAX - SINKMIN);
        // initialize animated drop color:
        m_color = new GLfloat[4];
        m_color[0] = 0.5;
        m_color[1] = 0.5;
        m_color[2] = 0.5;
        m_color[3] = 0.5;
};
    ~JifVerticalRect();
    bool procMovement(int x, int y);
    int pick(int button, int state, int x, int y);
    void animate(float offset);
    
    float getHorizontal(){return m_horizontalOffset;};
    float getBottomData(){return m_bottomData;};
    float getTopData(){return m_topData;};
    
    void setTop(float newTop);
    void setBottomData(float data){m_bottomData = data;};

};

#endif