//
//  Sinkapater.h
//  
//
//  Created by Jiffer Harriman on 11/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#ifndef SINKAPATER_H
#define SINKAPATER_H

#include "JifGL.h"
#include "JifChannel.h"
#include "chuck_fft.h"
#include "AudioFileSet.h"

#include <stdlib.h>
#include <stdio.h>

class Sinkapater {
    int m_numFaucets;
    //JifChannel * m_masterChannel;
    MasterDrop * m_masterDrop;
    JifChannel * m_masterChannel;
    JifChannel ** m_chanArray;
    SAMPLE ** m_mixBufArray;
    SAMPLE ** m_rmsBuffer;// made double pointer
    int m_rmsPointer;
    int m_bufferSize;
    float * m_window;
    float * m_taperWindow;
    
    bool m_animate;
    bool m_play;
    
    GLfloat * m_color;// ring color
    
    // keep track of changes to the master beat rate or number of beats
    int m_masterBeatRate;
    int m_masterNumBeats; // do I need this?  can't this be calculated to updat the beatrate 
    
    
public:
    Sinkapater(int NChan, int bufSize);
    Sinkapater(int NChan, int bufSize, vector<AudioFile *> * audioFiles);
    Sinkapater(JifDrop * masterDrop, JifChannel * masterChannel, int NChan, int bufSize);
    Sinkapater(JifDrop * masterDrop, JifChannel * masterChannel, int NChan, int bufSize, vector<AudioFile *> * audioFiles);
    ~Sinkapater(){};
    
    MasterDrop * getMasterDrop(){return m_masterDrop;};
    JifChannel * getFirstChannel(){return m_chanArray[0];};
    
    void init(int NChan, int bufSize);
    
    // reshape function
    void setWindowShape(int w, int h);
    
    // display function
    void draw(GLenum); // Add a bool here to pass in if we are animating or in edit mode
    void drawWaves();
    void drawRings();
    
    // motion function
    void procMovement(int x, int y);
    
    // mouse function
    void pick(int button, int state, int x, int y);
    
    void tick(SAMPLE * buffer, int bufferSize);
    
    void toggleAnimate();
    bool getAnimate(){return m_animate;};
    void togglePlay();
};

#endif