//
//  SlaveDrop.cpp
//  glMovingLines
//
//  Created by Jiffer Harriman on 12/9/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#include "SlaveDrop.h"

SlaveDrop::SlaveDrop(){
    
}

SlaveDrop::~SlaveDrop(){
    
}

SlaveDrop::SlaveDrop(MasterDrop * master, int numBeats, int repeatRate, float freq) :JifDrop(numBeats, repeatRate, freq)
{
    m_numBeatsMaster = INITMASTERDROPS;
    m_masterDrop = master;     
    m_currentBeatMaster = 0;
    m_isMaster = 0;

}

SlaveDrop::SlaveDrop(MasterDrop * master, int numBeats, int repeatRate, AudioFile * audioFile):JifDrop(numBeats, repeatRate, audioFile)
{
    m_numBeatsMaster = INITMASTERDROPS;
    m_masterDrop = master;    
    m_currentBeatMaster = 0;
    m_isMaster = 0;
}



bool SlaveDrop::masterBeatRateChanged(){
    if (m_oldMbr != m_masterDrop->getBeatRate()){
        // should I update the oldMbr here?
        m_oldMbr = m_masterDrop->getBeatRate();
        return true;
    }
    else 
        return false;
}

void SlaveDrop::tick(SAMPLE * outputBuffer, unsigned int bufferSize)
{
    if (m_play){

        for (int i = 0; i<bufferSize; i++){
            //outputBuffer[i] = m_pattern[m_currentBeat] * m_adsr->tick() * ( m_blit->tick());    
            advance();
            if (m_useSample){
                if(m_sampleCount < m_audio->lengthSamps/m_audio->channels)
                    outputBuffer[i] = m_rev->tick(m_beatEnabled[m_currentBeat] * m_audio->wave[m_audio->channels * m_sampleCount]);
                else
                    outputBuffer[i] = m_rev->tick(0);
            }
            else
                outputBuffer[i] = m_rev->tick( m_adsr->tick() * ( m_blit->tick())); 
        }
    }
    if (m_mute)
    {
        for(int i = 0; i<bufferSize; i++)
            outputBuffer[i] = 0;
    }

}

// Go to the next sample step, beat interval and trigger sound if necessary
void SlaveDrop::advance()
{  
    bool trigger = false;
    
    // check if master has triggered
    if (m_masterDrop->getSampleCount() == 0)
        m_currentBeatMaster++;
    if (m_currentBeatMaster > m_numBeatsMaster){
        m_currentBeatMaster = 0;
        trigger = true;
    }
    
    // Check if the sample count is equal to the beat rate in samples and if the current beat is enabled    
    if (m_sampleCount >= m_beatRate || trigger)
    {
        // reset sample count
        m_sampleCount = 0;
        
        // if beat is enabled play it:
        if (m_beatEnabled[m_currentBeat] == true)
            m_adsr->keyOn();
        else
            m_adsr->keyOff();
        
        // increment the current beat
        m_currentBeat++;
        if (m_currentBeat >= m_numBeats)
            m_currentBeat = 0;
    }
    m_sampleCount++;
}