//
//  SlaveDrop.h
//  glMovingLines
//
//  Created by Jiffer Harriman on 12/9/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//
#ifndef SLAVEDROP_H
#define SLAVEDROP_H
#include "MasterDrop.h"
#include "JifDrop.h"

class SlaveDrop : public JifDrop 
{
    // keeping track of where it is relative to the master:
    MasterDrop * m_masterDrop;
    int m_numBeatsMaster;
    int m_currentBeatMaster;  // how many master beats have passed - reset all after numBeatsMaster of these
    int m_oldMbr;
    
public:
    SlaveDrop();
    ~SlaveDrop();
    SlaveDrop(MasterDrop * masterDrop, int numBeats, int repeatRate, float freq);
    SlaveDrop(MasterDrop * masterDrop, int numBeats, int repeatRate, AudioFile * audioFile);
    
    void setMasterNumBeats(int newMasterNumBeats){m_numBeatsMaster = newMasterNumBeats;};
    int getMasterNumBeats(){return m_numBeatsMaster;};
    float getBeatsPerMaster(){
        float bpm =  (float)((float)(m_masterDrop->getBeatRate())/(float) m_beatRate);
        return bpm;
    };
    bool masterBeatRateChanged();
    
    void tick(SAMPLE * buffer, unsigned int size);
    void advance();    
    
};

#endif