//
//  main.cpp
//  glMovingLines
//
//  Created by Jiffer Harriman on 11/18/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#include "main.h"
#include "JifRect.h"
#include "MyAudio.h"
#include "AudioFileSet.h"


//-----------------------------------------------
// name: audioCallback
// desc: This simply calls the kitchenSink->tick method to get the next sample 
// and increment time and beat pointers as necessary
//-----------------------------------------------
int audioCallback( void * outputBuffer, void * inputBuffer, 
                  unsigned int bufferSize, double streamTime,
                  RtAudioStreamStatus status, void * userData )
{
    SAMPLE * out = (SAMPLE *)outputBuffer;
    
    //theSink->tick((SAMPLE *) out, bufferSize);
    //theKitchen->theSinks[currentSink]->tick((SAMPLE *) out, bufferSize);
    theKitchen->tick((SAMPLE *) out, bufferSize);
    // if "play" increment time // maybe per faucet - freeze muted tracks?
    
    return 0;
}

///////
// OpenGL stuff
/////
void jifpick(int button, int state, int x, int y){
    //theSink->pick(button, state, x, y);
    theKitchen->theSinks[currentSink]->pick(button, state, x, y);
}

void jifdisplay(void)
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    theKitchen->draw(currentSink);
    
    glFlush();
    glutSwapBuffers( );
}

// Process movement callback
void processMovement(int x, int y)
{
//    theSink->procMovement(x, y);
    for (int i = 0; i < NUMSINKS; i++){
        theKitchen->theSinks[i]->procMovement(x,y);
    }
}

void jif_gl_init(int argc, char **argv, int w, int h){
    // initial window settings
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
    glutInitWindowSize (w, h);
    glutInitWindowPosition (100, 100);
    glutCreateWindow("Sinkapater");

    // initial state
    glClearColor(0.0, 0.0, 0.0, 0.0);
    glEnable(GL_DEPTH_TEST);
    glEnable(GL_LINE_SMOOTH);
    glShadeModel(GL_FLAT);
    glDepthRange(0.0, 1.0);  /* The default z mapping */

    // assign glut function calls
    glutIdleFunc(idleFunc);
    glutMotionFunc(processMovement);
    
    glutReshapeFunc(reshape);
    glutDisplayFunc(jifdisplay);
    glutMouseFunc(jifpick);
    glutKeyboardFunc(keyboard);
    glutSpecialFunc( specialFunc );

}


/*  Main Loop
 */
int main(int argc, char **argv)
{
  //  theSink = new Sinkapater(INITCHANS, BUFFER_SIZE);
    theKitchen = new JifKitchen(BUFFER_SIZE);
    
    // config audio 
    MyAudio audio( NCHAN, MY_SRATE, BUFFER_SIZE );
    audio.setup( &audioCallback, theSink );
    
    // start audio
    audio.start();
    
    int bufSize = audio.bufferSize();

    theKitchen = new JifKitchen(bufSize);
    
    jif_gl_init(argc, argv, WIDTH, HEIGHT);

    glutMainLoop();
    return 0; 
}